/*
 *  tables.c - ASCII/EBCDIC conversion tables and 3270 screen address
 *	       mapping table for fs3270.c
 *
 *	version 0.0 - October 14, 1984, Paul G. Milazzo, Rice University
 *
 *	Copyright (c) October 1984, Paul G. Milazzo
 */

#include "3270_enc.h"


unsigned char	addrmap[] = {
	0x40, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
	0xc8, 0xc9, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,
	0x50, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,
	0xd8, 0xd9, 0x5a, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f,
	0x60, 0x61, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7,
	0xe8, 0xe9, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,
	0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
	0xf8, 0xf9, 0x7a, 0x7b, 0x7c, 0x7d, 0x7e, 0x7f
};


/* ebcdic to 3270 character generator xlate table */

#ifndef ORIGINAL
#undef CG_NULLBLANK
#undef CG_OVERBAR1
#undef CG_OVERBAR2
#undef CG_OVERBAR3
#undef CG_OVERBAR4
#undef CG_OVERBAR5
#undef CG_OVERBAR6
#undef CG_OVERBAR7

#define CG_NULLBLANK CG_BLANK
#define CG_OVERBAR1 CG_BLANK
#define CG_OVERBAR2 CG_BLANK
#define CG_OVERBAR3 CG_BLANK
#define CG_OVERBAR4 CG_BLANK
#define CG_OVERBAR5 CG_BLANK
#define CG_OVERBAR6 CG_BLANK
#define CG_OVERBAR7 CG_BLANK


#endif
 
unsigned char	ebc2cg[256] = {
	CG_NULLBLANK,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_OVERBAR2,	CG_OVERBAR6,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_OVERBAR3,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_OVERBAR1,	CG_PERIOD,	CG_PERIOD,
	CG_DUP,		CG_PERIOD,	CG_FM,		CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,	CG_OVERBAR4,
	CG_BLANK,	CG_LBRACKET,	CG_RBRACKET,	CG_POUND,
	CG_YEN,		CG_PT,		CG_CURRENCY,	CG_SHARPS,
	CG_SECTION,	CG_OVERSCORE,	CG_CENT,	CG_PERIOD,
	CG_LESS,	CG_LPAREN,	CG_PLUS,	CG_SOLIDBAR,
	CG_AMPERSAND,	CG_DEGREE,	CG_BREVE,	CG_CIRCUMFLEX,
	CG_DIAERESIS,	CG_ACUTE,	CG_CEDILLA,	CG_LAACUTE1,
	CG_LEACUTE1,	CG_LIACUTE1,	CG_EXCLAMATION,	CG_DOLLAR,
	CG_ASTERISK,	CG_RPAREN,	CG_SEMICOLON,	CG_NOT,
	CG_MINUS,	CG_FSLASH,	CG_LOACUTE1,	CG_LUACUTE1,
	CG_LATILDE,	CG_LOTILDE,	CG_LYDIAERESIS,	CG_LAACUTE2,
	CG_LEACUTE2,	CG_LEGRAVE1,	CG_BROKENBAR,	CG_COMMA,
	CG_PERCENT,	CG_UNDERSCORE,	CG_GREATER,	CG_QUESTION,
	CG_LIACUTE2,	CG_LOACUTE2,	CG_LUACUTE2,	CG_LUDIAERESIS1,
	CG_LCCEDILLA1,	CG_LADIAERESIS,	CG_LEDIAERESIS,	CG_LIDIAERESIS,
	CG_LODIAERESIS,	CG_GRAVE,	CG_COLON,	CG_NUMBER,
	CG_AT,		CG_SQUOTE,	CG_EQUAL,	CG_DQUOTE,
	CG_LUDIAERESIS2,CG_LA,		CG_LB,		CG_LC,
	CG_LD,		CG_LE,		CG_LF,		CG_LG,
	CG_LH,		CG_LI,		CG_LACIRCUMFLEX,CG_LECIRCUMFLEX,
	CG_LICIRCUMFLEX,CG_LOCIRCUMFLEX,CG_LUCIRCUMFLEX,CG_LAGRAVE,
	CG_LEGRAVE2,	CG_LJ,		CG_LK,		CG_LL,
	CG_LM,		CG_LN,		CG_LO,		CG_LP,
	CG_LQ,		CG_LR,		CG_LIGRAVE,	CG_LOGRAVE,
	CG_LUGRAVE,	CG_LNTILDE,	CG_CAACUTE,	CG_CEACUTE,
	CG_CIACUTE,	CG_TILDE,	CG_LS,		CG_LT,
	CG_LU,		CG_LV,		CG_LW,		CG_LX,
	CG_LY,		CG_LZ,		CG_COACUTE,	CG_CUACUTE,
	CG_CATILDE,	CG_COTILDE,	CG_CY1,		CG_CA1,
	CG_CE1,		CG_CE2,		CG_CI1,		CG_CO1,
	CG_CU1,		CG_CY2,		CG_CC1,		CG_CADIAERESIS,
	CG_CEDIAERESIS,	CG_CIDIAERESIS,	CG_CODIAERESIS,	CG_CUDIAERESIS,
	CG_CACIRCUMFLEX,CG_CECIRCUMFLEX,CG_CICIRCUMFLEX,CG_COCIRCUMFLEX,
	CG_LBRACE,	CG_CA,		CG_CB,		CG_CC,
	CG_CD,		CG_CE,		CG_CF,		CG_CG,
	CG_CH,		CG_CI,		CG_CUCIRCUMFLEX,CG_CAGRAVE,
	CG_CEGRAVE,	CG_CIGRAVE,	CG_PERIOD,	CG_PERIOD,
	CG_RBRACE,	CG_CJ,		CG_CK,		CG_CL,
	CG_CM,		CG_CN,		CG_CO,		CG_CP,
	CG_CQ,		CG_CR,		CG_COGRAVE,	CG_CUGRAVE,
	CG_CNTILDE,	CG_PERIOD,	CG_PERIOD,	CG_PERIOD,
	CG_BSLASH,	CG_LAE,		CG_CS,		CG_CT,
	CG_CU,		CG_CV,		CG_CW,		CG_CX,
	CG_CY,		CG_CZ,		CG_SSLASH0,	CG_LADOT,
	CG_LCCEDILLA2,	CG_PERIOD,	CG_PERIOD,	CG_MINUS,
	CG_ZERO,	CG_ONE,		CG_TWO,		CG_THREE,
	CG_FOUR,	CG_FIVE,	CG_SIX,		CG_SEVEN,
	CG_EIGHT,	CG_NINE,	CG_CAE,		CG_BSLASH0,
	CG_CADOT,	CG_CCCEDILLA,	CG_MINUS,	CG_OVERBAR7
};

/* 3270 character generator to ebcdic xlate table */
/* generated programmatically from ebc2cg */

unsigned char	cg2ebc[256] = {
	0x00, 0x19, 0x0c, 0x15, 0x3f, 0x00, 0x0d, 0xff,	/* 0x00 */
	0x6e, 0x4c, 0x41, 0x42, 0x5d, 0x4d, 0xd0, 0xc0,
	0x40, 0x7e, 0x7d, 0x7f, 0x61, 0xe0, 0x4f, 0x6a,	/* 0x10 */
	0x6f, 0x5a, 0x5b, 0x4a, 0x43, 0x44, 0x45, 0x46,
	0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,	/* 0x20 */
	0xf8, 0xf9, 0x47, 0x48, 0x7b, 0x7c, 0x6c, 0x6d,
	0x50, 0x60, 0x4b, 0x6b, 0x7a, 0x4e, 0x5f, 0x49,	/* 0x30 */
	0x51, 0x52, 0x53, 0xa1, 0x54, 0x79, 0x55, 0x56,
	0x57, 0x58, 0x59, 0x62, 0x63, 0x64, 0x65, 0x66,	/* 0x40 */
	0x67, 0x68, 0x69, 0x70, 0x71, 0x72, 0x73, 0x74,
	0x75, 0x76, 0x77, 0x78, 0x80, 0x8a, 0x8b, 0x8c,	/* 0x50 */
	0x8d, 0x8e, 0x8f, 0x90, 0x9a, 0x9b, 0x9c, 0x9d,
	0x9e, 0x9f, 0xa0, 0xaa, 0xab, 0xac, 0xad, 0xae,	/* 0x60 */
	0xaf, 0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6,
	0xb7, 0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0xbe,	/* 0x70 */
	0xbf, 0xca, 0xcb, 0xcc, 0xcd, 0xda, 0xdb, 0xdc,
	0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88,	/* 0x80 */
	0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
	0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,	/* 0x90 */
	0xa8, 0xa9, 0xe1, 0xea, 0xeb, 0xec, 0x1e, 0x1c,
	0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8,	/* 0xA0 */
	0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,
	0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7,	/* 0xB0 */
	0xe8, 0xe9, 0xfa, 0xfb, 0xfc, 0xfd, 0x5e, 0x5c,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	/* 0xC0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	/* 0xD0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	/* 0xE0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	/* 0xF0 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};







